/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package GUI;

import Game.Card;
import Game.Card.Rank;
import Game.Card.Suit;
import Game.Hand;
import java.awt.Graphics;
import java.awt.Image;
import java.util.EnumSet;
import javax.swing.JPanel;

/**
 *
 * @author A.M. Bosch, S080431
 */
public class NoFocusCardView extends JPanel {

    //constructor
    public NoFocusCardView() {
        super();
    }

    //variables
    private int numCards = -1;
    private Image[] pHand = new Image[8];
    boolean cardsVisible = false;
    boolean vertical = true;


    /**
     * updates the playerCardView with a new hand
     * @param hand, non-null object
     */
    public void updateNoFocusCardView(Hand hand){
        CardImage cardImage = CardImage.getCardImage();                         //reference to CardImage
        numCards = hand.getCardCount();                                         //numCards becomes number of cards

        for (int i = 0; i < numCards; i++){                                     //Translates hand object to their respective images and stores them in pHand
            pHand[i] = cardImage.getImageByCard(hand.getCard(i));
        }
        repaint();                                                              //repaint the playerCardPanel
    }

    /**
     * Set whether NoFocusCardView prints cards vertically or horizontally
     * @param bool
     */
    public void setVertical(boolean bool) {
        vertical = bool;
    }

    /**
     * Set whether the cards are visible or invisible (only card backs are printed)
     * @param bool
     */
    public void setCardsVisible(boolean bool){
        cardsVisible = bool;
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);

        Image backImage = CardImage.getCardImage().getBackImage();
        
        if (cardsVisible) {
            if (vertical) {
                for (int i = 0; i < numCards; i++) {
                    g.drawImage(pHand[i], 0, CardImage.YSPACING * i, this);         //Draws images from pHand, vertically spaced
                }
            } else {
                for (int i = 0; i < numCards; i++){
                    g.drawImage(pHand[i], CardImage.XSPACING * i, 0, this);        //Draws images from pHand, horizontally spaced
                }
            }
        } else {
            if (vertical) {
                for (int i = 0; i < numCards; i++) {
                    g.drawImage(backImage, 0, CardImage.YSPACING * i, this);      //Draws cardBacks, horizontally spaced
                }
            } else {
                for (int i = 0; i < numCards; i++) {
                    g.drawImage(backImage, CardImage.XSPACING * i, 0, this);      //Draws cardBacks, horizontally spaced
                }
            }
        }
    }
    
}

